Index: trunk/NEMOGCM/NEMO/OPA_SRC/FLO/flo4rk.F90
===================================================================
--- trunk/NEMOGCM/NEMO/OPA_SRC/FLO/flo4rk.F90	(revision 2527)
+++ trunk/NEMOGCM/NEMO/OPA_SRC/FLO/flo4rk.F90	(revision 2528)
@@ -11,5 +11,4 @@
    !!   flo_interp     : interpolation
    !!----------------------------------------------------------------------
-   !! * Modules used
    USE flo_oce         ! ocean drifting floats
    USE oce             ! ocean dynamics and tracers
@@ -20,21 +19,20 @@
    PRIVATE
 
-   !! * Accessibility
-   PUBLIC flo_4rk      ! routine called by floats.F90
-
-   !! * Module variables
-   REAL(wp), DIMENSION (4) ::   &   ! RK4 and Lagrange interpolation
-      tcoef1 = (/  1.0  ,  0.5  ,  0.5  ,  0.0  /) ,  &  ! coeffients  for 
-      tcoef2 = (/  0.0  ,  0.5  ,  0.5  ,  1.0  /) ,  &  ! lagrangian interp.
-      scoef2 = (/  1.0  ,  2.0  ,  2.0  ,  1.0  /) ,  &  ! RK4 coefficients
-      rcoef  = (/-1./6. , 1./2. ,-1./2. , 1./6. /)       ! ???
-   REAL(wp), DIMENSION (3) ::   &
-      scoef1 = (/ .5, .5, 1. /)       ! compute position with interpolated
-   !!----------------------------------------------------------------------
-   !!   OPA 9.0 , LOCEAN-IPSL (2005) 
+   PUBLIC   flo_4rk    ! routine called by floats.F90
+
+   !                                   ! RK4 and Lagrange interpolation coefficients
+   REAL(wp), DIMENSION (4) ::   tcoef1 = (/  1.0  ,  0.5  ,  0.5  ,  0.0  /)   ! 
+   REAL(wp), DIMENSION (4) ::   tcoef2 = (/  0.0  ,  0.5  ,  0.5  ,  1.0  /)   !
+   REAL(wp), DIMENSION (4) ::   scoef2 = (/  1.0  ,  2.0  ,  2.0  ,  1.0  /)   !
+   REAL(wp), DIMENSION (4) ::   rcoef  = (/-1./6. , 1./2. ,-1./2. , 1./6. /)   !
+   REAL(wp), DIMENSION (3) ::   scoef1 = (/  0.5  ,  0.5  ,  1.0  /)           !
+
+   !! * Substitutions
+#  include "domzgr_substitute.h90"
+   !!----------------------------------------------------------------------
+   !! NEMO/OPA 3.3 , NEMO Consortium (2010)
    !! $Id$ 
-   !! This software is governed by the CeCILL licence see modipsl/doc/NEMO_CeCILL.txt 
-   !!----------------------------------------------------------------------
-
+   !! Software governed by the CeCILL licence     (NEMOGCM/NEMO_CeCILL.txt)
+   !!----------------------------------------------------------------------
 CONTAINS
 
@@ -50,17 +48,11 @@
       !!         We need to know the velocity field, the old positions of the
       !!       floats and the grid defined on the domain.
+      !!----------------------------------------------------------------------
+      INTEGER, INTENT(in) ::   kt   ! ocean time-step index
       !!
-      !!----------------------------------------------------------------------
-      !! * Arguments
-      INTEGER, INTENT(in) ::   kt     ! ocean time-step index
-
-      !! * Local declarations
       INTEGER ::  jfl, jind           ! dummy loop indices
-      REAL(wp), DIMENSION ( jpnfl)  ::   &
-         zgifl, zgjfl, zgkfl,   &     ! index RK  positions
-         zufl, zvfl, zwfl             ! interpolated velocity at the
-      ! float position 
-      REAL(wp), DIMENSION ( jpnfl, 4 )  ::    &
-         zrkxfl, zrkyfl, zrkzfl       ! RK coefficients
+      REAL(wp), DIMENSION(jpnfl)   ::   zgifl , zgjfl , zgkfl    ! index RK  positions
+      REAL(wp), DIMENSION(jpnfl)   ::   zufl  , zvfl  , zwfl     ! interpolated velocity at the float position 
+      REAL(wp), DIMENSION(jpnfl,4) ::   zrkxfl, zrkyfl, zrkzfl   ! RK coefficients
       !!---------------------------------------------------------------------
     
@@ -127,11 +119,10 @@
       END DO
        
-      DO  jind = 1, 4
-         
+      DO  jind = 1, 4         
+      
          ! for each step we compute the compute the velocity with Lagrange interpolation
-         CALL flo_interp(zgifl,zgjfl,zgkfl,zufl,zvfl,zwfl,jind)
+         CALL flo_interp( zgifl, zgjfl, zgkfl, zufl, zvfl, zwfl, jind )
          
          ! computation of Runge-Kutta factor
-         
          DO jfl = 1, jpnfl
             zrkxfl(jfl,jind) = rdt*zufl(jfl)
@@ -154,10 +145,10 @@
          END DO
       END DO
-
+      !
    END SUBROUTINE flo_4rk
 
 
    SUBROUTINE flo_interp( pxt , pyt , pzt ,      &
-      &                   pufl, pvfl, pwfl, kind )
+      &                   pufl, pvfl, pwfl, ki )
       !!----------------------------------------------------------------------
       !!                ***  ROUTINE flointerp  ***
@@ -169,28 +160,21 @@
       !!      compute velocity at the date and the position we need to
       !!      integrated with RK method.
+      !!----------------------------------------------------------------------
+      REAL(wp) , DIMENSION(jpnfl), INTENT(in   ) ::   pxt , pyt , pzt    ! position of the float
+      REAL(wp) , DIMENSION(jpnfl), INTENT(  out) ::   pufl, pvfl, pwfl   ! velocity at this position
+      INTEGER                    , INTENT(in   ) ::   ki                 !
       !!
-      !!----------------------------------------------------------------------
-      !! * Local declarations
-      INTEGER ::   &
-         kind,   &
-         jfl, jind1, jind2, jind3,   &
-         zsumu, zsumv, zsumw
-      INTEGER , DIMENSION  ( jpnfl  ) ::   &
-         iilu, ijlu, iklu,     &           ! nearest neighbour INDEX-u
-         iilv, ijlv, iklv,     &           ! nearest neighbour INDEX-v
-         iilw, ijlw, iklw                  ! nearest neighbour INDEX-w
-      INTEGER , DIMENSION  ( jpnfl, 4  ) ::   &
-         iidu, ijdu, ikdu,    &            ! 64 nearest neighbour INDEX-u
-         iidv, ijdv, ikdv,    &            ! 64 nearest neighbour INDEX-v
-         iidw, ijdw, ikdw                  ! 64 nearest neighbour INDEX-w
-      REAL(wp) , DIMENSION  ( jpnfl  ) ::   &
-         pxt , pyt , pzt,     &            ! position of the float
-         pufl, pvfl, pwfl                  ! velocity at this position
-      REAL(wp) , DIMENSION  ( jpnfl, 4, 4, 4 ) ::   &
-         ztufl, ztvfl, ztwfl               ! velocity at choosen time step
-      REAL(wp) , DIMENSION  ( jpnfl, 4 ) ::   &
-         zlagxu, zlagyu, zlagzu,   &       ! Lagrange  coefficients
-         zlagxv, zlagyv, zlagzv,   &
-         zlagxw, zlagyw, zlagzw
+      INTEGER  ::   jfl, jind1, jind2, jind3   ! dummy loop indices
+      REAL(wp) ::   zsumu, zsumv, zsumw        ! local scalar
+      INTEGER , DIMENSION(jpnfl)   ::   iilu, ijlu, iklu   ! nearest neighbour INDEX-u
+      INTEGER , DIMENSION(jpnfl)   ::   iilv, ijlv, iklv   ! nearest neighbour INDEX-v
+      INTEGER , DIMENSION(jpnfl)   ::   iilw, ijlw, iklw   ! nearest neighbour INDEX-w
+      INTEGER , DIMENSION(jpnfl,4) ::   iidu, ijdu, ikdu   ! 64 nearest neighbour INDEX-u
+      INTEGER , DIMENSION(jpnfl,4) ::   iidv, ijdv, ikdv   ! 64 nearest neighbour INDEX-v
+      INTEGER , DIMENSION(jpnfl,4) ::   iidw, ijdw, ikdw   ! 64 nearest neighbour INDEX-w
+      REAL(wp) , DIMENSION(jpnfl,4,4,4) ::   ztufl , ztvfl , ztwfl   ! velocity at choosen time step
+      REAL(wp) , DIMENSION(jpnfl,4)     ::   zlagxu, zlagyu, zlagzu   ! Lagrange  coefficients
+      REAL(wp) , DIMENSION(jpnfl,4)     ::   zlagxv, zlagyv, zlagzv   !    -           -
+      REAL(wp) , DIMENSION(jpnfl,4)     ::   zlagxw, zlagyw, zlagzw   !    -           -
       !!---------------------------------------------------------------------
       
@@ -208,31 +192,22 @@
          DO jfl = 1, jpnfl
             !  i-direction
-            IF( iilu(jfl) <= 2 ) THEN
-               iidu(jfl,jind1) = jind1
-            ELSE
-               IF( iilu(jfl) >= jpi-1 ) THEN
-                  iidu(jfl,jind1) = jpi + jind1 - 4
-               ELSE
-                  iidu(jfl,jind1) = iilu(jfl) + jind1 - 2
+            IF( iilu(jfl) <= 2 ) THEN          ;   iidu(jfl,jind1) = jind1
+            ELSE
+               IF( iilu(jfl) >= jpi-1 ) THEN   ;   iidu(jfl,jind1) = jpi       + jind1 - 4
+               ELSE                            ;   iidu(jfl,jind1) = iilu(jfl) + jind1 - 2
                ENDIF
             ENDIF
             !  j-direction
-            IF( ijlu(jfl) <= 2 ) THEN
-               ijdu(jfl,jind1) = jind1
-            ELSE
-               IF( ijlu(jfl) >= jpj-1 ) THEN
-                  ijdu(jfl,jind1) = jpj + jind1 - 4
-               ELSE
-                  ijdu(jfl,jind1) = ijlu(jfl) + jind1 - 2
+            IF( ijlu(jfl) <= 2 ) THEN          ;   ijdu(jfl,jind1) = jind1
+            ELSE
+               IF( ijlu(jfl) >= jpj-1 ) THEN   ;   ijdu(jfl,jind1) = jpj       + jind1 - 4
+               ELSE                            ;   ijdu(jfl,jind1) = ijlu(jfl) + jind1 - 2
                ENDIF
             ENDIF
             ! k-direction
-            IF( iklu(jfl) <= 2 ) THEN
-               ikdu(jfl,jind1) = jind1
-            ELSE
-               IF( iklu(jfl) >= jpk-1 ) THEN
-                  ikdu(jfl,jind1) = jpk + jind1 - 4
-               ELSE
-                  ikdu(jfl,jind1) = iklu(jfl) + jind1 - 2
+            IF( iklu(jfl) <= 2 ) THEN          ;   ikdu(jfl,jind1) = jind1
+            ELSE
+               IF( iklu(jfl) >= jpk-1 ) THEN   ;   ikdu(jfl,jind1) = jpk + jind1 - 4
+               ELSE                            ;   ikdu(jfl,jind1) = iklu(jfl) + jind1 - 2
                ENDIF
             ENDIF
@@ -241,5 +216,4 @@
       
       ! Lagrange coefficients
-      
       DO jfl = 1, jpnfl
          DO jind1 = 1, 4
@@ -249,5 +223,4 @@
          END DO
       END DO
-      
       DO jind1 = 1, 4
          DO jind2 = 1, 4
@@ -269,6 +242,6 @@
                DO jind3 = 1, 4
                   ztufl(jfl,jind1,jind2,jind3) =   &
-                     &   (  tcoef1(kind) * ub(iidu(jfl,jind1),ijdu(jfl,jind2),ikdu(jfl,jind3)) +   &
-                     &      tcoef2(kind) * un(iidu(jfl,jind1),ijdu(jfl,jind2),ikdu(jfl,jind3)) )   &
+                     &   (  tcoef1(ki) * ub(iidu(jfl,jind1),ijdu(jfl,jind2),ikdu(jfl,jind3)) +   &
+                     &      tcoef2(ki) * un(iidu(jfl,jind1),ijdu(jfl,jind2),ikdu(jfl,jind3)) )   &
                      &      / e1u(iidu(jfl,jind1),ijdu(jfl,jind2)) 
                END DO
@@ -301,31 +274,22 @@
          DO jfl = 1, jpnfl
             ! i-direction
-            IF( iilv(jfl) <= 2 ) THEN
-               iidv(jfl,jind1) = jind1
-            ELSE
-               IF( iilv(jfl) >= jpi-1 ) THEN
-                  iidv(jfl,jind1) = jpi + jind1 - 4
-               ELSE
-                  iidv(jfl,jind1) = iilv(jfl) + jind1 - 2
+            IF( iilv(jfl) <= 2 ) THEN          ;   iidv(jfl,jind1) = jind1
+            ELSE
+               IF( iilv(jfl) >= jpi-1 ) THEN   ;   iidv(jfl,jind1) = jpi       + jind1 - 4
+               ELSE                            ;   iidv(jfl,jind1) = iilv(jfl) + jind1 - 2
                ENDIF
             ENDIF
             ! j-direction
-            IF( ijlv(jfl) <= 2 ) THEN
-               ijdv(jfl,jind1) = jind1
-            ELSE
-               IF( ijlv(jfl) >= jpj-1 ) THEN
-                  ijdv(jfl,jind1) = jpj + jind1 - 4
-               ELSE
-                  ijdv(jfl,jind1) = ijlv(jfl) + jind1 - 2
+            IF( ijlv(jfl) <= 2 ) THEN          ;   ijdv(jfl,jind1) = jind1
+            ELSE
+               IF( ijlv(jfl) >= jpj-1 ) THEN   ;   ijdv(jfl,jind1) = jpj       + jind1 - 4
+               ELSE                            ;   ijdv(jfl,jind1) = ijlv(jfl) + jind1 - 2
                ENDIF
             ENDIF
             ! k-direction
-            IF( iklv(jfl) <= 2 ) THEN
-               ikdv(jfl,jind1) = jind1
-            ELSE
-               IF( iklv(jfl) >= jpk-1 ) THEN
-                  ikdv(jfl,jind1) = jpk + jind1 - 4
-               ELSE
-                  ikdv(jfl,jind1) = iklv(jfl) + jind1 - 2
+            IF( iklv(jfl) <= 2 ) THEN          ;   ikdv(jfl,jind1) = jind1
+            ELSE
+               IF( iklv(jfl) >= jpk-1 ) THEN   ;   ikdv(jfl,jind1) = jpk + jind1 - 4
+               ELSE                            ;   ikdv(jfl,jind1) = iklv(jfl) + jind1 - 2
                ENDIF
             ENDIF
@@ -347,7 +311,7 @@
             DO jfl = 1, jpnfl
                IF( jind1 /= jind2 ) THEN
-                  zlagxv(jfl,jind1)= zlagxv(jfl,jind1)*(pxt(jfl) - (float(iidv(jfl,jind2))) )
+                  zlagxv(jfl,jind1)= zlagxv(jfl,jind1)*(pxt(jfl) - (float(iidv(jfl,jind2))   ) )
                   zlagyv(jfl,jind1)= zlagyv(jfl,jind1)*(pyt(jfl) - (float(ijdv(jfl,jind2))+.5) )
-                  zlagzv(jfl,jind1)= zlagzv(jfl,jind1)*(pzt(jfl) - (float(ikdv(jfl,jind2))) )
+                  zlagzv(jfl,jind1)= zlagzv(jfl,jind1)*(pzt(jfl) - (float(ikdv(jfl,jind2))   ) )
                ENDIF
             END DO
@@ -362,6 +326,6 @@
                DO jind3 = 1 ,4
                   ztvfl(jfl,jind1,jind2,jind3)=   &
-                     &   ( tcoef1(kind) * vb(iidv(jfl,jind1),ijdv(jfl,jind2),ikdv(jfl,jind3))  +   &
-                     &     tcoef2(kind) * vn(iidv(jfl,jind1),ijdv(jfl,jind2),ikdv(jfl,jind3)) )    & 
+                     &   ( tcoef1(ki) * vb(iidv(jfl,jind1),ijdv(jfl,jind2),ikdv(jfl,jind3))  +   &
+                     &     tcoef2(ki) * vn(iidv(jfl,jind1),ijdv(jfl,jind2),ikdv(jfl,jind3)) )    & 
                      &     / e2v(iidv(jfl,jind1),ijdv(jfl,jind2))
                END DO
@@ -385,7 +349,7 @@
       ! nearest neightboring point for computation of w 
       DO jfl = 1, jpnfl
-         iilw(jfl) = INT(pxt(jfl))
-         ijlw(jfl) = INT(pyt(jfl))
-         iklw(jfl) = INT(pzt(jfl)+.5)
+         iilw(jfl) = INT( pxt(jfl)   )
+         ijlw(jfl) = INT( pyt(jfl)   )
+         iklw(jfl) = INT( pzt(jfl)+.5)
       END DO
       
@@ -394,44 +358,32 @@
          DO jfl = 1, jpnfl
             ! i-direction
-            IF( iilw(jfl) <= 2 ) THEN
-               iidw(jfl,jind1) = jind1
-            ELSE
-               IF( iilw(jfl) >= jpi-1 ) THEN
-                  iidw(jfl,jind1) = jpi + jind1 - 4
-               ELSE
-                  iidw(jfl,jind1) = iilw(jfl) + jind1 - 2
+            IF( iilw(jfl) <= 2 ) THEN          ;   iidw(jfl,jind1) = jind1
+            ELSE
+               IF( iilw(jfl) >= jpi-1 ) THEN   ;   iidw(jfl,jind1) = jpi       + jind1 - 4
+               ELSE                            ;   iidw(jfl,jind1) = iilw(jfl) + jind1 - 2
                ENDIF
             ENDIF
             ! j-direction
-            IF( ijlw(jfl) <= 2 ) THEN
-               ijdw(jfl,jind1) = jind1
-            ELSE
-               IF( ijlw(jfl) >= jpj-1 ) THEN
-                  ijdw(jfl,jind1) = jpj + jind1 - 4
-               ELSE
-                  ijdw(jfl,jind1) = ijlw(jfl) + jind1 - 2
+            IF( ijlw(jfl) <= 2 ) THEN          ;   ijdw(jfl,jind1) = jind1
+            ELSE
+               IF( ijlw(jfl) >= jpj-1 ) THEN   ;   ijdw(jfl,jind1) = jpj       + jind1 - 4
+               ELSE                            ;   ijdw(jfl,jind1) = ijlw(jfl) + jind1 - 2
                ENDIF
             ENDIF
             ! k-direction
-            IF( iklw(jfl) <= 2 ) THEN
-               ikdw(jfl,jind1) = jind1
-            ELSE
-               IF( iklw(jfl) >= jpk-1 ) THEN
-                  ikdw(jfl,jind1) = jpk + jind1 - 4
-               ELSE
-                  ikdw(jfl,jind1) = iklw(jfl) + jind1 - 2
-               ENDIF
-            ENDIF
-         END DO
-      END DO
-      DO jind1 = 1, 4
-         DO jfl = 1, jpnfl
-            IF( iklw(jfl) <= 2 ) THEN
-               ikdw(jfl,jind1) = jind1
-            ELSE
-               IF( iklw(jfl) >= jpk-1 ) THEN
-                  ikdw(jfl,jind1) = jpk + jind1 - 4
-               ELSE
-                  ikdw(jfl,jind1) = iklw(jfl) + jind1 - 2
+            IF( iklw(jfl) <= 2 ) THEN          ;   ikdw(jfl,jind1) = jind1
+            ELSE
+               IF( iklw(jfl) >= jpk-1 ) THEN   ;   ikdw(jfl,jind1) = jpk       + jind1 - 4
+               ELSE                            ;   ikdw(jfl,jind1) = iklw(jfl) + jind1 - 2
+               ENDIF
+            ENDIF
+         END DO
+      END DO
+      DO jind1 = 1, 4
+         DO jfl = 1, jpnfl
+            IF( iklw(jfl) <= 2 ) THEN          ;   ikdw(jfl,jind1) = jind1
+            ELSE
+               IF( iklw(jfl) >= jpk-1 ) THEN   ;   ikdw(jfl,jind1) = jpk       + jind1 - 4
+               ELSE                            ;   ikdw(jfl,jind1) = iklw(jfl) + jind1 - 2
                ENDIF
             ENDIF
@@ -440,5 +392,4 @@
       
       ! Lagrange coefficients  for w interpolation
-      
       DO jfl = 1, jpnfl
          DO jind1 = 1, 4
@@ -448,11 +399,10 @@
          END DO
       END DO
-       
       DO jind1 = 1, 4
          DO jind2 = 1, 4
             DO jfl = 1, jpnfl
                IF( jind1 /= jind2 ) THEN
-                  zlagxw(jfl,jind1) = zlagxw(jfl,jind1) * (pxt(jfl) - (float(iidw(jfl,jind2))) )
-                  zlagyw(jfl,jind1) = zlagyw(jfl,jind1) * (pyt(jfl) - (float(ijdw(jfl,jind2))) )
+                  zlagxw(jfl,jind1) = zlagxw(jfl,jind1) * (pxt(jfl) - (float(iidw(jfl,jind2))   ) )
+                  zlagyw(jfl,jind1) = zlagyw(jfl,jind1) * (pyt(jfl) - (float(ijdw(jfl,jind2))   ) )
                   zlagzw(jfl,jind1) = zlagzw(jfl,jind1) * (pzt(jfl) - (float(ikdw(jfl,jind2))-.5) )
                ENDIF
@@ -462,5 +412,4 @@
       
       ! velocity w  when we compute at middle time step
-      
       DO jfl = 1, jpnfl
          DO jind1 = 1, 4
@@ -468,13 +417,12 @@
                DO jind3 = 1, 4
                   ztwfl(jfl,jind1,jind2,jind3)=   &
-                     &   ( tcoef1(kind) * wb(iidw(jfl,jind1),ijdw(jfl,jind2),ikdw(jfl,jind3))+   &
-                     &     tcoef2(kind) * wn(iidw(jfl,jind1),ijdw(jfl,jind2),ikdw(jfl,jind3)) )  &
-!!bug e3w instead of fse3 
-                     &   / e3w(ikdw(jfl,jind3))
+                     &   ( tcoef1(ki) * wb(iidw(jfl,jind1),ijdw(jfl,jind2),ikdw(jfl,jind3))+   &
+                     &     tcoef2(ki) * wn(iidw(jfl,jind1),ijdw(jfl,jind2),ikdw(jfl,jind3)) )  &
+                     &   / fse3w(iidw(jfl,jind1),ijdw(jfl,jind2),ikdw(jfl,jind3))
                END DO
             END DO
          END DO
          
-         zsumw=0.
+         zsumw = 0.e0
          DO jind1 = 1, 4
             DO jind2 = 1, 4
@@ -487,14 +435,11 @@
          pwfl(jfl) = zsumw
       END DO
-      
+      !   
    END SUBROUTINE flo_interp
 
 #  else
    !!----------------------------------------------------------------------
-   !!   Default option                                         Empty module
-   !!----------------------------------------------------------------------
-CONTAINS
-   SUBROUTINE flo_4rk                 ! Empty routine
-   END SUBROUTINE flo_4rk
+   !!   No floats                                              Dummy module
+   !!----------------------------------------------------------------------
 #endif
    
Index: trunk/NEMOGCM/NEMO/OPA_SRC/FLO/flo_oce.F90
===================================================================
--- trunk/NEMOGCM/NEMO/OPA_SRC/FLO/flo_oce.F90	(revision 2527)
+++ trunk/NEMOGCM/NEMO/OPA_SRC/FLO/flo_oce.F90	(revision 2528)
@@ -20,24 +20,24 @@
    !! float parameters
    !! ----------------
-   INTEGER, PUBLIC, PARAMETER ::   jpnfl     = 23 ,                !: total number of floats during the run
-   INTEGER, PUBLIC, PARAMETER ::   jpnnewflo =  0 ,                !: number of floats added in a new run
+   INTEGER, PUBLIC, PARAMETER ::   jpnfl     = 23                  !: total number of floats during the run
+   INTEGER, PUBLIC, PARAMETER ::   jpnnewflo =  0                  !: number of floats added in a new run
    INTEGER, PUBLIC, PARAMETER ::   jpnrstflo = jpnfl - jpnnewflo   !: number of floats for the restart
 
    !! float variables
    !! ---------------
-   INTEGER, PUBLIC, DIMENSION(jpnfl)  ::   nisobfl   !: =0 for a isobar float , =1 for a float following the w velocity
-   INTEGER, PUBLIC, DIMENSION(jpnfl)  ::   ngrpfl    !: number to identify searcher group
+   INTEGER , PUBLIC, DIMENSION(jpnfl) ::   nisobfl   !: =0 for a isobar float , =1 for a float following the w velocity
+   INTEGER , PUBLIC, DIMENSION(jpnfl) ::   ngrpfl    !: number to identify searcher group
 
-   REAL(wp), PUBLIC, DIMENSION(jpnfl) ::   flxx , flyy , flzz    !: longitude, latitude, depth of float (decimal degree, m >0)
+   REAL(wp), PUBLIC, DIMENSION(jpnfl) ::   flxx , flyy , flzz    !: long, lat, depth of float (decimal degree, m >0)
    REAL(wp), PUBLIC, DIMENSION(jpnfl) ::   tpifl, tpjfl, tpkfl   !: (i,j,k) indices of float position
 
-   REAL(wp), PUBLIC, DIMENSION(jpi, jpj, jpk) ::   wb            !: vertical velocity at previous time step (m s-1).
+   REAL(wp), PUBLIC, DIMENSION(jpi,jpj,jpk) ::   wb              !: vertical velocity at previous time step (m s-1).
    
-   !                                  !!! * namelist namflo : langrangian floats *
+   !                                            !!! * namelist namflo : langrangian floats *
    LOGICAL, PUBLIC  ::   ln_rstflo  = .FALSE.    !: T/F float restart 
    LOGICAL, PUBLIC  ::   ln_argo    = .FALSE.    !: T/F argo type floats
    LOGICAL, PUBLIC  ::   ln_flork4  = .FALSE.    !: T/F 4th order Runge-Kutta
-   INTEGER, PUBLIC  ::   nn_writefl = 150       !: frequency of float output file 
-   INTEGER, PUBLIC  ::   nn_stockfl = 450       !: frequency of float restart file
+   INTEGER, PUBLIC  ::   nn_writefl = 150        !: frequency of float output file 
+   INTEGER, PUBLIC  ::   nn_stockfl = 450        !: frequency of float restart file
 
 #else
@@ -49,7 +49,7 @@
 
    !!----------------------------------------------------------------------
-   !! NEMO/OPA 3.2 , LOCEAN-IPSL (2009) 
+   !! NEMO/OPA 3.3 , NEMO Consortium (2010)
    !! $Id$ 
-   !! Software governed by the CeCILL licence (modipsl/doc/NEMO_CeCILL.txt)
+   !! Software governed by the CeCILL licence     (NEMOGCM/NEMO_CeCILL.txt)
    !!======================================================================
 END MODULE flo_oce
Index: trunk/NEMOGCM/NEMO/OPA_SRC/FLO/floats.F90
===================================================================
--- trunk/NEMOGCM/NEMO/OPA_SRC/FLO/floats.F90	(revision 2527)
+++ trunk/NEMOGCM/NEMO/OPA_SRC/FLO/floats.F90	(revision 2528)
@@ -14,4 +14,5 @@
    !!   flo_init  : initialization of float trajectories computation
    !!----------------------------------------------------------------------
+   USE oce             ! ocean variables
    USE flo_oce         ! floats variables
    USE lib_mpp         ! distributed memory computing
@@ -20,4 +21,5 @@
    USE flo4rk          ! Trajectories, Runge Kutta scheme (flo_4rk routine)
    USE floblk          ! Trajectories, Blanke scheme      (flo_blk routine)
+   USE in_out_manager  ! I/O manager
 
    IMPLICIT NONE
@@ -25,11 +27,11 @@
 
    PUBLIC   flo_stp    ! routine called by step.F90
+   PUBLIC   flo_init   ! routine called by opa.F90
 
    !!----------------------------------------------------------------------
-   !! NEMO/OPA 3.2 , LOCEAN-IPSL (2009) 
+   !! NEMO/OPA 3.3 , NEMO Consortium (2010)
    !! $Id$ 
-   !! Software governed by the CeCILL licence (modipsl/doc/NEMO_CeCILL.txt)
+   !! Software governed by the CeCILL licence     (NEMOGCM/NEMO_CeCILL.txt)
    !!----------------------------------------------------------------------
-
 CONTAINS
 
@@ -52,6 +54,4 @@
          IF(lwp) WRITE(numout,*) 'flo_stp : call floats routine '
          IF(lwp) WRITE(numout,*) '~~~~~~~'
-
-         CALL flo_init           ! read the namelist of floats             
 
          CALL flo_dom            ! compute/read initial position of floats
@@ -80,6 +80,4 @@
       !! ** Purpose :   Read the namelist of floats
       !!----------------------------------------------------------------------
-      USE ioipsl
-      !!
       NAMELIST/namflo/ ln_rstflo, nn_writefl, nn_stockfl, ln_argo, ln_flork4 
       !!---------------------------------------------------------------------
@@ -91,9 +89,9 @@
          WRITE(numout,*)
          WRITE(numout,*) '         Namelist floats :'
-         WRITE(numout,*) '            restart                          ln_rstflo = ', ln_rstflo
-         WRITE(numout,*) '            frequency of float output file   nn_writefl  = ', nn_writefl
-         WRITE(numout,*) '            frequency of float restart file  nn_stockfl  = ', nn_stockfl
-         WRITE(numout,*) '            Argo type floats                 ln_argo   = ', ln_argo
-         WRITE(numout,*) '            Computation of T trajectories    ln_flork4 = ', ln_flork4
+         WRITE(numout,*) '            restart                          ln_rstflo  = ', ln_rstflo
+         WRITE(numout,*) '            frequency of float output file   nn_writefl = ', nn_writefl
+         WRITE(numout,*) '            frequency of float restart file  nn_stockfl = ', nn_stockfl
+         WRITE(numout,*) '            Argo type floats                 ln_argo    = ', ln_argo
+         WRITE(numout,*) '            Computation of T trajectories    ln_flork4  = ', ln_flork4
       ENDIF
       !
@@ -108,4 +106,6 @@
       WRITE(*,*) 'flo_stp: You should not have seen this print! error?', kt
    END SUBROUTINE flo_stp
+   SUBROUTINE flo_init          ! Empty routine
+   END SUBROUTINE flo_init
 #endif
 
Index: trunk/NEMOGCM/NEMO/OPA_SRC/FLO/floblk.F90
===================================================================
--- trunk/NEMOGCM/NEMO/OPA_SRC/FLO/floblk.F90	(revision 2527)
+++ trunk/NEMOGCM/NEMO/OPA_SRC/FLO/floblk.F90	(revision 2528)
@@ -8,9 +8,6 @@
    !!   'key_floats'                                     float trajectories
    !!----------------------------------------------------------------------
-
-   !!----------------------------------------------------------------------
    !!    flotblk     : compute float trajectories with Blanke algorithme
    !!----------------------------------------------------------------------
-   !! * Modules used
    USE flo_oce         ! ocean drifting floats
    USE oce             ! ocean dynamics and tracers
@@ -23,15 +20,13 @@
    PRIVATE
 
-   !! * Accessibility
-   PUBLIC flo_blk      ! routine called by floats.F90
+   PUBLIC   flo_blk    ! routine called by floats.F90
 
    !! * Substitutions
 #  include "domzgr_substitute.h90"
    !!----------------------------------------------------------------------
-   !!   OPA 9.0 , LOCEAN-IPSL (2005) 
+   !! NEMO/OPA 3.3 , NEMO Consortium (2010)
    !! $Id$ 
-   !! This software is governed by the CeCILL licence see modipsl/doc/NEMO_CeCILL.txt 
-   !!----------------------------------------------------------------------
-
+   !! Software governed by the CeCILL licence     (NEMOGCM/NEMO_CeCILL.txt)
+   !!----------------------------------------------------------------------
 CONTAINS
 
@@ -46,10 +41,7 @@
       !!      algorithm. We need to know the velocity field, the old positions
       !!      of the floats and the grid defined on the domain.
+      !!----------------------------------------------------------------------
+      INTEGER, INTENT( in  ) ::   kt ! ocean time step
       !!
-      !!----------------------------------------------------------------------
-      !! * arguments
-      INTEGER, INTENT( in  ) ::   kt ! ocean time step
-
-      !! * Local declarations
       INTEGER :: jfl              ! dummy loop arguments
       INTEGER :: ind, ifin, iloop
@@ -78,6 +70,5 @@
          zsurfz,                    &     ! surface of the face of the mesh 
          zind
-      REAL(wp), DIMENSION ( 2 )  ::   &
-         zsurfx, zsurfy                   ! surface of the face of the mesh
+      REAL(wp), DIMENSION ( 2 )  ::   zsurfx, zsurfy   ! surface of the face of the mesh
       !!---------------------------------------------------------------------
       
@@ -111,5 +102,5 @@
       iloop = 0
 222   DO jfl = 1, jpnfl
-# if   defined key_mpp_mpi   ||   defined key_mpp_shmem
+# if   defined key_mpp_mpi
          IF( (iil(jfl) >= (mig(nldi)-jpizoom+1)) .AND. (iil(jfl) <= (mig(nlei)-jpizoom+1)) .AND.   &
              (ijl(jfl) >= (mjg(nldj)-jpjzoom+1)) .AND. (ijl(jfl) <= (mjg(nlej)-jpjzoom+1)) ) THEN
@@ -327,5 +318,5 @@
             ! reinitialisation of the age of FLOAT
             zagefl(jfl) = zagenewfl(jfl)
-# if   defined key_mpp_mpi   ||   defined key_mpp_shmem
+# if   defined key_mpp_mpi
          ELSE
             ! we put zgifl, zgjfl, zgkfl, zagefl
@@ -413,5 +404,5 @@
          GO TO 222
       ENDIF
-
+      !
    END SUBROUTINE flo_blk
 
